/*********************************************************************
 * Desktop Station air Sketch for RP2040 Hardware Platform
 *
 * Copyright (C) 2023 DesktopStation Co.,Ltd. / Yaasan
 * https://desktopstation.net/
 */
 
#include <WiFi.h>
#include <WiFiClient.h>
#include <WebServer.h>
#include "webapp.h"
#include "webapp_html.h"

#define USER_WEBAPP_FILE "dsairlite_wapp.min.html.gz"

void reply200Ok(WiFiClient client)
{
	long aPos = 0;
	
	
    // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
    // and a content-type so the client knows what's coming, then a blank line:
    client.println("HTTP/1.1 200 OK");
    client.println("Content-type:text/html");
    //client.println("Content-Encoding: gzip");
    //client.println();
	
	//client.write( (uint8_t *)dsairlite_wapp_min_html_gz, dsairlite_wapp_min_html_gz_len);

    // The HTTP response ends with another blank line:
    client.println();
	
}

void replyWebApp(WiFiClient client)
{
	long aPos = 0;
	
	
    // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
    // and a content-type so the client knows what's coming, then a blank line:
    client.println("HTTP/1.1 200 OK");
    client.println("Content-type:text/html");
    client.println("Content-Encoding: gzip");
    client.println();
	
	client.write( (uint8_t *)dsairlite_wapp_min_html_gz, dsairlite_wapp_min_html_gz_len);

    // The HTTP response ends with another blank line:
    client.println();
	
}

bool IsUserWebApp()
{
	bool aRet = false;
	File f;
	
	//LittleFS 開始
	LittleFS.begin();
	
	//File Open
	f = LittleFS.open(USER_WEBAPP_FILE,"r");
	
	if (!f)
	{
		aRet = false;
	}
	else
	{
		aRet = true;
	}
	
	f.close();
	
	return aRet;
}

void replyUserWebApp(WiFiClient client)
{
	long aPos = 0;
	File f;
	static uint8_t buf[512];
	size_t len = 0;
	
	client.println("HTTP/1.1 200 OK");
	client.println("Content-type:text/html");
	
	//LittleFS 開始
	LittleFS.begin();
	
	
	//File Open
	
	f = LittleFS.open(USER_WEBAPP_FILE,"r");
	
	if (!f)
	{
		
		client.println();
		client.println("ERROR: NO USER WEBAPPP FOUND.");
		
		return;
	}
	else
	{
		//ユーザーWebAPPをバイナリで返す
		client.println("Content-Encoding: gzip");
		client.println();
		
		len = f.size();
		size_t flen = len;
		
		while (len)
		{
			size_t toRead = len;
			
			if (toRead > 512)
			{
				toRead = 512;
			}
			
			f.read(buf, toRead);
			client.write( (uint8_t *)buf, toRead);
			
			len -= toRead;
		}
		
		

		
		client.println();
		
	}
	
	f.close();
}
